%define enable_japanese 1

%define sysconfdir	/etc
%define localstatedir	/var/lib

%define preferdb	--enable-prefer-db1

%define dbdir db.1.85
%define dbinclude %{dbdir}/include
%define dblib %{dbdir}/PORT/linux

Name:		gnome-libs
Version: 	1.4.1.2.90
Release:	14.2
Epoch:		1
Summary: The main GNOME libraries.
Copyright:	LGPL
Group: System Environment/Libraries
Source: 	ftp://ftp.gnome.org/pub/GNOME/sources/stable/%{name}/%{name}-%{version}.tar.gz
URL:		http://www.gnome.org/
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
Requires:	gtk+ >= 1.2.5
Requires:	ORBit
Requires:	imlib
Requires:	esound

BuildRequires:	zlib-devel
BuildRequires:	imlib-devel
BuildRequires:	esound-devel
BuildRequires:	ORBit-devel
BuildRequires:	glib-devel
BuildRequires:	gtk+-devel
BuildRequires:  /usr/bin/automake-1.4

## from db1
%ifnarch ia64
Conflicts: glibc < 2.1.90
%endif


# Added to avoid the warning messages about utmp group, bug #24171
PreReq:                utempter

Source2:       gnome-libs-pofiles.tar.gz

Source3:       db.1.85.tar.gz

# Red Hat patches
Patch:		RH-gnome-libs-rhsnddefs.patch
Patch2:		RH-gnome-libs-echok.patch
#Patch4:         gnome-libs-applix-mime.patch
Patch5:         gnome-libs-gtkrc.patch
Patch6:         gnome-libs-1.0.55-safeprop.patch
Patch7:		gnome-libs-1.2.4-scrolling.patch
Patch8:		gnome-libs-1.2.13-zvtmb.patch
# Helix patches

# i18n patches
Patch22:        gtk-xmhtml-wordwrap-990930.patch
Patch23:        gtk-xmhtml-fontsizes.patch
Patch24:        gnome-libs-1.0.53-fontset.patch
Patch25: http://www.kr.freebsd.org/~hwang/patch/gnome-icon-item.c-preedit-diff
Patch26:	gtk-xmhtml-wordwrap-alnum.patch
Patch27:	gnome-libs-1.2.13-utf8menu.patch
Patch28:	gnome-libs-1.2.13-gnome-canvas-aa.patch
Patch29:        gnome-libs-1.2.8-kdesm.patch
Patch30:        gnome-libs-1.2.13-kdemenus.patch
Patch31:        gnome-libs-1.2.13-noxalf.patch
Patch32:        gnome-libs-1.2.13-notearoffs.patch
# Nullify master_client if it gets destroyed (#14872)
Patch33:        gnome-libs-1.2.13-mastercleanup.patch
# Enable setting canvas into a "bghack" mode with gtk_object_set_data
Patch34:        gnome-libs-1.2.13-bghack.patch
# Fix understandable misunderstanding of imlib memory management
Patch35:        gnome-libs-1.2.13-imlibref.patch
Patch36:        gnome-libs-1.2.13-mdash.patch
Patch37:        gnome-libs-1.2.13-initialurl.patch
Patch38:        gnome-libs-1.2.13-zvthomeend.patch
Patch39:        gnome-libs-1.2.13-prototypes.patch
#Patch40:        gnome-libs-1.4.1.2.90-png10.patch
#Patch41:        gnome-libs-1.4.1.2.90-db1.patch
Patch42:        gnome-libs-1.4.1.2.90-ac25.patch
Patch43:        gnome-libs-1.4.1.2.90-paste.patch
Patch44:        gnome-libs-1.4.1.2.90-alpha_size_t.patch

Patch50:        gnome-libs-1.2.13-config-dir-variable.patch
Patch51:        gnome-libs-1.2.13-atomic-config-files.patch

## db1 patches
Patch80: db.1.85.patch
Patch81: db.1.85.s390.patch
Patch82: db.1.85.nodebug.patch

%description
GNOME (GNU Network Object Model Environment) is a user-friendly set of
GUI applications and desktop tools to be used in conjunction with a
window manager for the X Window System. The gnome-libs package
includes libraries that are needed to run GNOME.

%package devel
Summary: Libraries and headers for GNOME application development.
Group: Development/Libraries
Requires:	%name = %{version}
Requires:	gtk+-devel
Requires:	ORBit-devel
Requires:	imlib-devel
Requires:	esound-devel

## from db1
%ifnarch ia64
Conflicts: glibc-devel < 2.1.90
%endif

%description devel
GNOME (GNU Network Object Model Environment) is a user-friendly set of
GUI applications and desktop tools to be used in conjunction with a
window manager for the X Window System. The gnome-libs-devel package
includes the libraries and include files that you will need to develop
GNOME applications.

You should install the gnome-libs-devel package if you would like to
develop GNOME applications. You do not need to install gnome-libs-devel
if you just want to use the GNOME desktop environment.

%prep
%setup -q -a 3

%patch  -p1
%patch2 -p1
#%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1 -b .scrolling
%patch8 -p1 -b .zvtmb
%if %{enable_japanese}
%patch22 -p1 -b .wordwrap
%patch23 -p1 -b .fontsize
# seems to be upstream
## %patch24 -p1 -b .about
%patch25 -p0 -b .iconedit
%patch26 -p1 -b .alnum
%patch28 -p1 -b .aa
%endif
%patch27 -p1 -b .utf8menu
%patch29 -p1 -b .kdesm
%patch30 -p1 -b .kdemenus
%patch31 -p1 -b .noxalf
%patch32 -p1 -b .notearoffs
%patch33 -p1 -b .mastercleanup
%patch34 -p1 -b .bghack
%patch36 -p1 -b .mdash
%patch37 -p1 -b .mdash
%patch38 -p1 -b .zvthomeend
%patch39 -p1 -b .prototypes
## using a perl munge instead to avoid rerunning autoconf
# %patch40 -p1 -b .png10
#%patch41 -p1 -b .db1
%patch42 -p1 -b .ac25
%patch43 -p1 -b .paste
%patch44 -p1 -b .alpha_size_t

%patch50 -p1 -b .config-dir-variable
%patch51 -p1 -b .atomic-config-files

# translations
tar zxf %{SOURCE2}

cd %{dbdir}

%patch80 -p1 -b .patch
%patch81 -p1 -b .fPIC
%patch82 -p1 -b .nodebug

## back to main dir
cd $RPM_BUILD_DIR/%{name}-%{version}

%build

## to db 
#cd %{dbdir}

#gzip -9 docs/*.ps
#(cd include && ln -sf db.h db_185.h)
#cd PORT/linux
#make OORG="$RPM_OPT_FLAGS"

## back to main dir
#cd $RPM_BUILD_DIR/%{name}-%{version}

# so we don't get the wrong libpng or have gcc whining
perl -pi -e 's@-I\$\(includedir\)[^/]?@@g' `find -name Makefile.am`

libtoolize --copy --force
automake-1.4

echo "dbinclude is: " %{dbinclude}

# bad hacks because configure below seems to ignore CPPFLAGS, and because 
# re-running autoconf breaks the AC_CONFIG_SUBDIRS(libart_lgpl)
#perl -pi -e 's/-lpng/-lpng10/g' configure
perl -pi -e 's@-I */usr/include[^/]?@@g' configure
#perl -pi -e 's@\$CPPFLAGS@\$CPPFLAGS'" -I$RPM_BUILD_DIR/%{name}-%{version}/%{dbinclude}"@g configure
#perl -pi -e 's@\$LDFLAGS@\$LDFLAGS'" -L$RPM_BUILD_DIR/%{name}-%{version}/%{dblib}"@g configure

## CPPFLAGS="-I $RPM_BUILD_DIR/%{name}-%{version}/%{dbinclude}"          \
## CFLAGS="$RPM_OPT_FLAGS -L $RPM_BUILD_DIR/%{name}-%{version}/%{dblib}" \
#CFLAGS="$RPM_OPT_FLAGS -I/usr/include/png-1.0" 
%configure --with-kde-datadir=%{_datadir} %{preferdb}

#perl -pi -e 's/-ldb1//g' gnome-config
#perl -pi -e 's/-ldb//g' gnome-config

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

## to db 
#cd %{dbdir}
#mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/{include/db1,lib,bin}

#sed -n '/^\/\*-/,/^ \*\//s/^.\*.\?//p' include/db.h | grep -v '^@.*db\.h' > LICENSE

#perl -pi -e 's/<db.h>/<db1\/db.h>/' PORT/include/ndbm.h

#cd PORT/linux
#sover=`echo libdb.so.* | sed 's/libdb.so.//'`
#install -m644 libdb.a			$RPM_BUILD_ROOT/%{_prefix}/lib/libdb1.a
#install -m755 libdb.so.$sover		$RPM_BUILD_ROOT/%{_prefix}/lib/libdb1.so.$sover
#ln -sf libdb1.so.$sover 		$RPM_BUILD_ROOT/%{_prefix}/lib/libdb1.so
#ln -sf libdb1.so.$sover			$RPM_BUILD_ROOT/%{_prefix}/lib/libdb.so.$sover
#install -m644 ../include/ndbm.h		$RPM_BUILD_ROOT/%{_prefix}/include/db1/
#install -m644 ../../include/db.h	$RPM_BUILD_ROOT/%{_prefix}/include/db1/
#install -m644 ../../include/mpool.h	$RPM_BUILD_ROOT/%{_prefix}/include/db1/
#install -s -m755 db_dump185		$RPM_BUILD_ROOT/%{_prefix}/bin/db1_dump185

## back to main dir
#cd $RPM_BUILD_DIR/%{name}-%{version}

%makeinstall

mv $RPM_BUILD_ROOT%{_prefix}/share/doc/gnome-doc $RPM_BUILD_ROOT%{_prefix}/bin
chmod a+x $RPM_BUILD_ROOT%{_prefix}/bin/gnome-doc
mv $RPM_BUILD_ROOT%{_prefix}/share/doc/mkstub $RPM_BUILD_ROOT%{_bindir}
chmod a+x $RPM_BUILD_ROOT%{_prefix}/bin/mkstub
mkdir -p $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp
mv $RPM_BUILD_ROOT%{_prefix}/share/doc/gnome-doc.el $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp

%find_lang %name

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(-, root, root)

%doc AUTHORS COPYING ChangeLog NEWS README %{dbdir}/README %{dbdir}/LICENSE %{dbdir}/changelog
%{_libdir}/lib*.so.*
%{_bindir}/dns-helper
%{_bindir}/gconfigger
%{_bindir}/gnome-bug
%{_bindir}/gnome-dump-metadata
%{_bindir}/gnome-gen-mimedb
%{_bindir}/gnome-moz-remote
%{_bindir}/gnome-name-service
%{_bindir}/gnome_segv
%{_bindir}/goad-browser
%{_bindir}/loadshlib
%{_bindir}/new-object
%attr(2755, root, utmp) %{_prefix}/sbin/gnome-pty-helper
%{_datadir}/idl/*
%{_datadir}/pixmaps/*
%{_datadir}/mime-info/gnome.mime
%{_datadir}/type-convert/type.convert
%config %{sysconfdir}/*

## db1 pieces
#%{_prefix}/lib/libdb1.so.*
#%{_prefix}/lib/libdb.so.*
#%{_prefix}/bin/db1_dump185

%files devel
%defattr(-, root, root)

%{_bindir}/gnome-config
%{_bindir}/libart-config
%{_bindir}/gnome-doc
%{_bindir}/mkstub
%{_libdir}/lib*.so
%{_libdir}/*.a
%{_libdir}/*.sh
%{_libdir}/gnome-libs
%{_prefix}/include/*
%{_datadir}/aclocal/*
%{_datadir}/gnome/html
%{_datadir}/emacs/site-lisp/gnome-doc.el

## db1 devel pieces don't get installed
## %doc docs/*.ps.gz
## %{_prefix}/include/db1
## %{_prefix}/lib/libdb1.a
## %{_prefix}/lib/libdb1.so


%changelog
* Sat Dec 21 2002 Havoc Pennington <hp@redhat.com>
- fix #78609

* Tue Nov  5 2002 Havoc Pennington <hp@redhat.com>
- include patch to relocate .gnome with env variable

* Mon Apr 15 2002 Havoc Pennington <hp@redhat.com>
- merge translations

* Tue Apr  9 2002 Havoc Pennington <hp@redhat.com>
- fix #58739 (crash on 64 bit due to size_t/int mixing)

* Tue Mar 12 2002 Havoc Pennington <hp@redhat.com>
- leave -ldb in gnome-config output for now, seems to be required
  for some reason

* Tue Mar  5 2002 Havoc Pennington <hp@redhat.com>
- comment out all the db1 and png10 stuff for now
- require /usr/bin/automake-1.4
- fix "can't paste more than 4K or so" #5308, someone thought 
  write() meant "write the whole buffer and always succeed"
- fix "can't paste from nedit/tk" #54185

* Mon Jan 28 2002 Havoc Pennington <hp@redhat.com>
- someday I'll get this package right (remove munging of 
  usr/include from gnome-config)

* Sun Jan 27 2002 Havoc Pennington <hp@redhat.com>
- -lpng10 patch didn't work since we can't run autoconf
  since it blows up on AC_CONFIG_SUBDIRS, so 
  instead add more perl munging of generated configure
- and also perl-munge to get rid of -I/usr/include

* Fri Jan 25 2002 Bill Nottingham <notting@redhat.com>
- hack in libdb1 reference in libgnome.so

* Wed Jan 23 2002 Havoc Pennington <hp@redhat.com>
- hmm, need to s/-ldb1/ first, then s/-ldb/, doh

* Wed Jan 23 2002 Havoc Pennington <hp@redhat.com>
- s/-ldb1//g in addition to s/-ldb//g in gnome-config

* Tue Jan 22 2002 Havoc Pennington <hp@redhat.com>
- include db1 in here; install libdb.so.2, libdb1.so.2, drop 
  our dependency on db1
- strip -ldb from gnome-config output

* Tue Jan  8 2002 Havoc Pennington <hp@redhat.com>
- make it link to -lpng10
- build require automake14, call automake-1.4 instead of automake

* Mon Oct 15 2001 Havoc Pennington <hp@redhat.com>
- CVS snap with fixed libart-config/libartConf.sh
- remove patch to gnome-about.c that Kjartaan put upstream

* Thu Sep 13 2001 Havoc Pennington <hp@redhat.com>
- upgrade to CVS snapshot, and move headers around
- remove imlibref patch, now upstream

* Mon Aug 27 2001 Havoc Pennington <hp@redhat.com>
- Add po files from sources.redhat.com

* Mon Aug 27 2001 Owen Taylor <otaylor@redhat.com>
- Fix missing prototype in multibyte patch, causing segfault on ia64 (#51987)
- Add various missing #includes, which were causing warnings and at least 
  one segfault.

* Wed Aug 22 2001 Havoc Pennington <hp@redhat.com>
- fix #48470, gnome-terminal Home/End keys

* Mon Aug 13 2001 Owen Taylor <otaylor@redhat.com>
- Fix problem displaying mdash in help browser

* Sun Aug 12 2001 Owen Taylor <otaylor@redhat.com>
- Fix problem with imlib memory management that produced crashes when
  switching themes (#51580)

* Thu Aug  2 2001 Owen Taylor <otaylor@redhat.com>
- Check if .desktop files are UTF-8 by examining entire file (#50447)
- Use a default type of Directory for all .directory files, not just for 
  old-style KDE files (#50558)

* Mon Jul 23 2001 Owen Taylor <otaylor@redhat.com>
- Clean up if master client is destroyed (#14872)
- 'nother attempt at the master-client fix
- Add hack for nautilus root window to gnome-libs

* Thu Jul 19 2001 Alexander Larsson <alexl@redhat.com>
- Add BuildRequires

* Fri Jul 13 2001 Alexander Larsson <alexl@redhat.com>
- Disable xalf by default
- Disable tearoff menus and menu bars

* Tue Jul 10 2001 Alexander Larsson <alexl@redhat.com>
- Added patch to handle substitution and icons in kde desktop entries

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Tue Apr 17 2001 Jonathan Blandford <jrb@redhat.com>
- upped version to 1.2.12.
- removed a lot of patches that had made their way to CVS.

* Thu Mar 15 2001 Havoc Pennington <hp@redhat.com>
- translations

* Thu Mar 01 2001 Owen Taylor <otaylor@redhat.com>
- Rebuild for gtk+-1.2.9

* Fri Feb 23 2001 Trond Eivind Glomsrd <teg@redhat.com>
- langify

* Mon Feb 19 2001 Havoc Pennington <hp@redhat.com>
- Fix paste to still try STRING even if we also try COMPOUND_TEXT, 
  bug 26971

* Thu Feb 08 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- add libtoolize to make porting to new archs easy

* Wed Feb 07 2001 Havoc Pennington <hp@redhat.com> 1.2.4-6
- Add utempter Prereq, bug #24171

* Wed Feb 07 2001 Havoc Pennington <hp@redhat.com>
- Apply patch from John Harper that makes GNOME apps work with the 
  KDE session manager.

* Wed Jan 31 2001 Akira TAGOH <tagoh@redhat.com>
- Fixed show multibyte character in gnome_canvas_new_aa ()

* Sun Jan 28 2001 Akira TAGOH <tagoh@redhat.com>
- Fixed show UTF-8 encoding KDE menu.

* Wed Jan 24 2001 Matt Wilson <msw@redhat.com>
- Japanese ideographs now show up in iswalnum, don't include it in the
  ideograph check (Patch26: gtk-xmhtml-wordwrap-alnum.patch)

* Wed Dec 27 2000 Matt Wilson <msw@redhat.com>
- enable japanese
- removed gnome-libs-1.2.4-druid-fontset.patch, in mainline

* Tue Dec 19 2000 Matt Wilson <msw@redhat.com>
- disabled i18n (asian) patches, but integrate patches into main package
- added iconlist im patch from CLE, currently disabled.
- 1.2.8
- removed gnome-libs-1.2.4-setbgfix.patch, in mainline
- removed gnome-libs-1.2.4-grabfix.patch, in mainline
- removed gnome-libs-1.2.4-doubleclicks.patch, in mainline
- removed gnome-libs-1.2.4-motionnotify.patch, in mainline
- removed gnome-libs-1.2.4-nosound.patch, in mainline
- removed alpha cflags hack

* Thu Sep  7 2000 Matt Wilson <msw@redhat.com>
- added patch for gtk-XmHTML wrapping
- added patch to ensure proper kanji display in about boxes (is this still needed?)
- added patch to tweak the fonts used for XmHTML to be readable in Japanese

* Tue Aug 29 2000 Yukihiro Nakai <ynakai@redhat.com>
- Add Japanese patches

* Wed Aug 23 2000 Elliot Lee <sopwith@redhat.com>
- Fix the mismatch of default settings between control-center and
gnome-libs. I am the true survivor!

* Sat Aug 19 2000 Havoc Pennington <hp@redhat.com>
- Always use SCROLL_NEVER mode as if transparency was on, 
  even if transparency is not on. This fixes 14744 but makes
  scrolling slow. Best we can do, sigh.

* Sat Aug 19 2000 Havoc Pennington <hp@redhat.com>
- Call gdk_window_get_pointer on motion notify, fixes bug
  16407, though I don't quite understand why it does

* Fri Aug 11 2000 Jonathan Blandford <jrb@redhat.com>
- Up Epoch and release

* Wed Aug 09 2000 Havoc Pennington <hp@redhat.com>
- Filter out double/triple clicks when doing scroll or paste

* Wed Aug 09 2000 Havoc Pennington <hp@redhat.com>
- fix for grabbing the pointer while selecting

* Sat Aug 05 2000 Havoc Pennington <hp@redhat.com>
- fix for failure to change background color post-realization

* Fri Aug 04 2000 Owen Taylor <otaylor@redhat.com>
- Add a Requires db1-devel to the devel package. (Bug #15394)

* Thu Aug 03 2000 Owen Taylor <otaylor@redhat.com>
- Rebuild to see if we can fix funny gnome-config junk
  problem. 

* Tue Jul 19 2000 Havoc Pennington <hp@redhat.com>
- Rebuild; were getting weird segfaults with tearoff dock items,
  rebuilding with debugging made it go away, hoping it was 
  a compiler bug.

* Wed Jul 12 2000 Havoc Pennington <hp@redhat.com>
- 1.2.4
- remove IDL fix patch, seems to have gone upstream

* Mon Jun 19 2000 Havoc Pennington <hp@redhat.com>
- Move elisp files and executables out of /usr/share/doc
- Add HTML docs to file list
- remove broken %%doc mess

* Thu Jun 15 2000 Jonathan Blandford <jrb@redhat.com>
- added bug fix to fix idl miscompilation.

* Fri Jun  9 2000 Matt Wilson <msw@redhat.com>
- 1.2.1
- rebuilt with gcc that has fixed C ABI

* Tue May 30 2000 Matt Wilson <msw@redhat.com>
- prefer db1

* Fri May 19 2000 Owen Taylor <otaylor@redhat.com>
- Upgrade to gnome-libs 1.0.62

* Mon Feb 21 2000 Preston Brown <pbrown@redhat.com>
- keyboard mapping follows debian policy, xterm

* Tue Feb 15 2000 Owen Taylor <otaylor@redhat.com>
- Add checks to make sure gnome-terminal survives if the
  bg pixmap vanishes.

* Fri Feb 11 2000 Owen Taylor <otaylor@redhat.com>
- Install gtkrc files in /etc/gnome

* Fri Feb 11 2000 Owen Taylor <otaylor@redhat.com>
- Remove broken alpha timeval fix, fix bug in configure.in
  that was misdetecting ut_tv field of utmpx

* Thu Feb 10 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix up escape sequences in zvt (Bug #9143)

* Fri Feb 04 2000 Elliot Lee <sopwith@redhat.com>
- Accept true/yes/non-zero as TRUE for gnome-config boolean values.

* Wed Feb 03 2000 Havoc Pennington <hp@redhat.com>
- set ECHOK for terminal widget, bug 8823

* Wed Feb 02 2000 Havoc Pennington <hp@redhat.com>
- include man pages in the file list, also bug 8017

* Wed Feb 02 2000 Havoc Pennington <hp@redhat.com>
- Fix an alpha warning bugzilla #8017

* Tue Feb 01 2000 Elliot Lee <sopwith@redhat.com>
- Update to 1.0.55

* Tue Aug 31 1999 Elliot Lee <sopwith@redhat.com>
- Update to 1.0.15

* Mon Aug 30 1999 Elliot Lee <sopwith@redhat.com>
- Merge in various minor things from RHL

* Mon Jun 14 1999 Gregory McLean <gregm@comstar.net>

- Added the -q option to the setup stage, quiet please!

* Tue Mar 2  1999 Gregory McLean <gregm@comstar.net>

- Added some hackage in for the brain dead libtool on the alpha
- Cleaned up the spec file abit to be more consistant.

* Wed Feb 17 1999 Elliot Lee <sopwith@redhat.com>

- Add debugging disabling flags to $CFLAGS

* Fri Nov 20 1998 Pablo Saratxaga <srtxg@chanae.alphanet.ch>

- use --localstatedir=/var/lib in config state (score files for games
  for exemple will go there).
- added several more files to %files section, in particular language
  files and corba IDLs

* Wed Sep 23 1998 Michael Fulbright <msf@redhat.com>

- Updated to version 0.30

* Mon Apr 13 1998 Marc Ewing <marc@redhat.com>
- Added %{prefix}/lib/gnome-libs

* Fri Mar 13 1998 Marc Ewing <marc@redhat.com>

- Integrate into gnome-libs source tree
